TARGET = mips64-nlm-elf

ifeq ("$(LE)", "1")
ENDIANNESS = -EL
EMUL = ltsmip
else
ENDIANNESS = -EB
EMUL = btsmip
endif

ifeq ("$(ABI)","64")
abi_flags = -mabi=64 -Wno-format
LDFLAGS  += -melf64$(EMUL)
else

ifeq ("$(ABI)","32")
##### 32 ####
abi_flags = -mabi=32 -Wno-format
LDFLAGS  += -melf32$(EMUL)

else

##### n32 ####
abi_flags = -mabi=n32
LDFLAGS  += -melf32$(EMUL)n32

endif #32

endif # 64

ASFLAGS  += $(abi_flags)
CFLAGS   += $(abi_flags)
CPPFLAGS += $(abi_flags)

ifeq ("$(XLR)", "1")
CFLAGS   += -march=xlr -msoft-float
ASFLAGS  += -march=xlr 
CPPFLAGS += -march=xlr
else
CFLAGS   += -march=xlp
ASFLAGS  += -march=xlp
CPPFLAGS += -march=xlp
endif

AS       =  $(TARGET)-gcc
CC       =  $(TARGET)-gcc
CXX      =  $(TARGET)-g++
LD       =  $(TARGET)-ld
AR       =  $(TARGET)-ar
RANLIB   =  $(TARGET)-ranlib
OBJDUMP  =  $(TARGET)-objdump
NM       =  $(TARGET)-nm
OBJCOPY  =  $(TARGET)-objcopy
STRIP    =  $(TARGET)-strip
READELF  =  $(TARGET)-readelf
AWK      =  awk

#
# Desired CFLAGS Setting 
#
ifeq ("$(XLR)", "1")
CFLAGS += -specs=$(NETOS_ROOT)/srcs/scripts/xlr_loader.spec
else
CFLAGS += -specs=$(NETOS_ROOT)/srcs/scripts/loader.spec
endif

ifeq ($(opt-level),)
opt-level = 3
endif

CFLAGS += -DNETOS -D__DYNAMIC_REENT__ $(ENDIANNESS) -O$(opt-level)
CFLAGS += -Wall #-Werror

ASFLAGS += -D__ASSEMBLY__ $(ENDIANNESS)
LINKFLAGS += -d -warn-common

#
# header file locations
#
CPPFLAGS += -I$(NETOS_ROOT)/srcs/include -I$(NETOS_ROOT)/srcs/include/sys_shared/
CPPFLAGS += -I$(HAL_DIR) -I$(FDT_DIR)/libfdt -I. -I$(FDT_DIR)/libfdt/contrib/

ifeq ("$(XLP_SIM)", "1")
CPPFLAGS   += -DXLP_SIM=1
CFLAGS   += -DXLP_SIM=1
endif

HAL_FLAGS = -DNLM_HAL_NETOS
CPPFLAGS += $(HAL_FLAGS)

ifeq ("$(CONFIG_XEN)", "1")
CFLAGS += -DCONFIG_XEN
endif

ifeq ("$(CONFIG_XEN_MDOM)", "1")
CFLAGS += -DCONFIG_XEN_MDOM
endif

export AS CC CXX LD AR RANLIB OBJDUMP NM OBJCOPY READELF AWK 
export NETOS_ROOT 
export CPPFLAGS ASFLAGS CFLAGS LDFLAGS ABI NETOS_TLB_REFILL_HANDLER
