#ifndef _DEVICES_H
#define _DEVICES_H

#include <sys/types.h>

struct device_ops {
	const char *name;
	int (*open_r)(struct _reent *reent, const char *path, int flags, int mode);
	int (*close_r)(struct _reent *reent, int fd);
	_ssize_t (*read_r)(struct _reent *reent, int fd, char *ptr, size_t len);
	_ssize_t (*write_r)(struct _reent *reent, int fd, const char *ptr, size_t len);

	void (*init)(void);
};

extern struct device_ops dev_stdio_in;
extern struct device_ops dev_stdio_out;
extern struct device_ops dev_stdio_err;
extern struct device_ops dev_tmpfs;

#endif /* _DEVICES_H */
