/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _MEM_CTRL_H
#define _MEM_CTRL_H

#define DDR2_CONFIG_REG_PARAMS_1          0
#define DDR2_CONFIG_REG_PARAMS_2          1
#define DDR2_CONFIG_REG_PARAMS_3          2
#define DDR2_CONFIG_REG_PARAMS_4          3
#define DDR2_CONFIG_REG_PARAMS_5          4
#define DDR2_CONFIG_REG_PARAMS_6          26
#define DDR2_CONFIG_REG_CLK_CALIBRATE_PARAMS 8
#define DDR2_CONFIG_REG_CLK_CALIBRATE_REQUEST 9

#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS0 (0x100>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS1 (0x104>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS2 (0x108>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS3 (0x10c>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS4 (0x110>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS5 (0x114>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS6 (0x118>>2)
#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_DQS7 (0x11c>>2)

#define DDR2_CONFIG_REG_CLK_CALIBRATION_RES_CMD 19
#define DDR2_CONFIG_REG_MRS 20
#define DDR2_CONFIG_REG_RDMRS 21
#define DDR2_CONFIG_REG_EMRS1 22
#define DDR2_CONFIG_REG_EMRS2 23
#define DDR2_CONFIG_REG_EMRS3 24
#define DDR2_CONFIG_REG_RESET_TIMERS 25

#define DDR2_CONFIG_REG_PARAMS_7 41
#define DDR2_CONFIG_REG_BNK_CTL 5
#define DDR2_CONFIG_REG_ADDRESS_PARAMS 6
#define DDR2_CONFIG_REG_ADDRESS_PARAMS2 27
#define DDR2_CONFIG_REG_GLB_PARAMS 7

#define DDR2_CONFIG_REG_RESET_CMD1 28
#define DDR2_CONFIG_REG_RESET_CMD2 29
#define DDR2_CONFIG_REG_RESET_CMD3 30
#define DDR2_CONFIG_REG_RESET_CMD4 31
#define DDR2_CONFIG_REG_RESET_CMD5 32
#define DDR2_CONFIG_REG_RESET_CMD6 33
#define DDR2_CONFIG_REG_RESET_CMD7 34

#define DDR2_CONFIG_REG_RMW_ECC_LOG 44
#define DDR2_CONFIG_REG_RMW_ECC_LOG_HI 35
#define DDR2_CONFIG_REG_ECC_POISON_MASK 36

#define DDR2_CONFIG_REG_POISON_MASK_0 37
#define DDR2_CONFIG_REG_POISON_MASK_1 38
#define DDR2_CONFIG_REG_POISON_MASK_2 39
#define DDR2_CONFIG_REG_POISON_MASK_3 40

#define DDR2_CONFIG_REG_WRITE_ODT_MASK 42
#define DDR2_CONFIG_REG_READ_ODT_MASK 43

#define DDR_COUNTER_CONF 45
#define DDR_PRF_COUNTER0 46
#define DDR_PRF_COUNTER1 47

#define RLD2_BASE_ADDRESS_REGISTER0 64
#define RLD2_BASE_ADDRESS_REGISTER1 65
#define MASTER_CONFIG_REGISTER0 66
#define MASTER_CONFIG_REGISTER1 67
#define DAR_REGISTER 68
#define INITIALIZE_REGISTER 69

#endif
