/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#include "xlr_boot_lib.h"
#include "list.h"

#define NTLBSZ 9

struct memblk_list {
	list_t list;
	unsigned int align;
};

typedef struct memblk_list memblk_list_t;

struct memblk {
	list_t list;
	uint64_t addr;
	uint64_t size;
};

typedef struct memblk memblk_t;

extern memblk_list_t kuseg_memblks[NTLBSZ];
extern unsigned int xlr_tlb_sizes[NTLBSZ];

extern uint64_t kuseg_avail_mem;

extern unsigned int best_fit_tlb_size(uint64_t, uint64_t);

extern int add_memblk(uint64_t addr, uint64_t size);
extern void init_kuseg_memblks(void);
extern uint64_t find_memblk(unsigned long vaddr);
extern unsigned long tlb_align_size(uint64_t size);
