/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
 *******************************#NETL_2#**********************************/

#ifndef _MM_H
#define _MM_H

#define PAGE_SIZE (1 << 12)
#if 0
#define KSEG0     (0xffffffff80000000ULL)
#define KSEG1     (0xffffffffA0000000ULL)
#define KSEG2     (0xffffffffC0000000ULL)
#define KSEG3     (0xffffffffE0000000ULL)
#define KSEG0_PHY_BOUNDARY 0x10000000ULL    // 256 MB
#endif
#define MAX_CPUS       32

#ifndef __ASSEMBLY__

#include "types.h"
#include "mips-exts.h"
#include "xlr_boot_lib.h"
#include "tlb.h"

extern volatile struct xlr_vcpu_wakeup_info *xlr_vcpu_wakeup_info;

extern void pte_init(int cpu, long eaddr);
extern unsigned long long app_endaddr;
void alloc_per_cpu_mem_space(void);
extern unsigned long long ptebase, excsp;

#define NETOS_EXC_STACK_SZ 8192

#endif /* __ASSEMBLY__ */

#endif /* _MM_H */
