/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#ifndef __CONTIG_ALLOC_PARAM_H__
#define __CONTIG_ALLOC_PARAM_H__

enum contig_alloc_call_e {
	NLM_CONTIGALLOC_CALL = 1,
	NLM_CONTIGCALLOC_CALL,
	NLM_CONTIGREALLOC_CALL,
	NLM_CONTIGMALIGN_CALL,
	NLM_CONTIGFREE_CALL,
	NLM_CONTIGPINFO_CALL
};

struct nlm_contig_alloc {
	unsigned long long size;
	unsigned long long memptr;
};

struct nlm_contig_calloc {
	unsigned long long nelem;
	unsigned long long elsize;
	unsigned long long memptr;

};

struct nlm_contig_realloc {
	unsigned long long obj;
	unsigned long long size;
	unsigned long long memptr;

};


struct nlm_contig_malign {
	unsigned long long align;
	unsigned long long size;
	unsigned long long memptr;

};

struct nlm_contig_free {
	unsigned long long memptr;
};

struct nlm_contig_pinfo {
	unsigned long long physstart;
	unsigned long long virtstart;
};


struct nlm_contig_alloc_call {
	int cmd;
	int rv; /* return value -1 or 0 */
	union {
		struct nlm_contig_alloc alloc;
		struct nlm_contig_calloc calloc;
		struct nlm_contig_realloc realloc;
		struct nlm_contig_malign malign;
		struct nlm_contig_free   free;
		struct nlm_contig_pinfo   pinfo;
	};
};





#endif
