/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#ifndef __NLM_SEMAPHORE_LOADER_H
#define __NLM_SEMAPHORE_LOADER_H

#include <list.h>
#include <semaphore.h>
#include <semparam.h>
#include <spinlock.h>
#include <irq.h>


struct semaphore
{
    sem_t sem;
    uint32_t magic;
    uint32_t users;
    char *name;
    int oflag;
    struct list list;
    int unlinked;
};

#define SEM_TO_SEMAPHORE(x) (struct semaphore *)(unsigned long)\
            ((unsigned long)x - (unsigned long)&((struct semaphore *)0UL)->sem)

#define MAX_SEM_HEAD 128

#define SEM_USER_MAX    (2147483647)
#define SEM_MAGIC       0x900ddeed
extern void semaphore_init();
extern int sem_sys_call(void *data);
#endif
