/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <fcntl.h>
#include "spinlock.h"
#include "pmemparam.h"

extern void hpexec_setup_tlb(unsigned long virt, uint64_t phys, uint64_t size);
extern void hpexec_clear_tlb(unsigned long virt, uint64_t phys, uint64_t size);
int pmem_sys_call(void *data)
{
	struct netl_pmemcall *m = data;
	
	switch(m->cmd)
	{
		case NETL_PMEM_MMAP_CALL:
		{
			struct netl_pmem_mmap *mmap = &m->mmap;
			hpexec_setup_tlb(mmap->vaddr, mmap->off, mmap->len); 
			break;
		}
		case NETL_PMEM_MUNMAP_CALL:
		{
			struct netl_pmem_munmap *munmap = &m->munmap;
			hpexec_clear_tlb(munmap->vaddr, munmap->off, munmap->len);
			break;
		}
		default:
			m->rv = -1;
			return -1;
	}
	m->rv = 0;
	return 0;
}
