#include <stdio.h>
#include <stdlib.h>

#include "cpu.h"
#include "system.h"
#include "cache.h"
#include "mips-exts.h"
#include "nlm_hal_macros.h"

static unsigned int icache_line_size;
static unsigned int dcache_line_size;

static unsigned int icache_assoc;
static unsigned int dcache_assoc;

static unsigned int icache_sets;
static unsigned int dcache_sets;

void ldr_flush_dcache_all(void)
{
	int i = 0;
	int dcache_lines = dcache_sets * dcache_assoc;
	unsigned long base = (unsigned long)KSEG0;

	for (i = 0; i < dcache_lines; i++) {
		cache_op(Index_Writeback_Inv_D, base);
		base += dcache_line_size;
	}
}

void ldr_flush_icache_all(void)
{
	int i = 0;
	int icache_lines = icache_sets * icache_assoc;
	unsigned long base = (unsigned long)KSEG0;

	icache_lines = icache_sets * icache_assoc;

	for (i = 0; i < icache_lines; i++) {
		cache_op(Index_Invalidate_I, base);
		base += icache_line_size;
	}
}

void read_cache_config(void) 
{
	unsigned int config1;
	/* Read the cache configuration */
	config1 = xlr_read_32bit_cp0_config1();

	icache_line_size = 1 << (((config1 >> 19) & 0x7) + 1);
	dcache_line_size = 1 << (((config1 >> 10) & 0x7) + 1);

	icache_sets = 1 << (((config1 >> 22) & 0x7)+6);
	dcache_sets = 1 << (((config1 >> 13) & 0x7)+6);

	icache_assoc = ((config1 >> 16) & 0x7) + 1;
	dcache_assoc = ((config1 >> 7) & 0x7) + 1;
}
