/***********************************************************************
Copyright 2003-2010 Netlogic Microsystems Inc. (“Netlogic”).
This is a derived work from software originally provided by the external
entity identified below. The licensing terms and warranties specified in
the header of the original work apply to this derived work.
*****************************#NETL_1#********************************/



/* sbrk.c -- allocate memory dynamically.
 * 
 * Copyright (c) 1995,1996 Cygnus Support
 *
 * The authors hereby grant penlmssion to use, copy, modify, distribute,
 * and license this software and its documentation for any purpose, provided
 * that existing copyright notices are retained in all copies and that this
 * notice is included verbatim in any distributions. No written agreement,
 * license, or royalty fee is required for any of the authorized uses.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 */
#include <errno.h>
#include "contig_alloc.h"

struct contig_mem *contig_mem_ptr = NULL;
/*
 * sbrk -- changes heap size size. Get nbytes more
 *         RAM. We just increment a pointer in what's
 *         left of memory on the board.
 */
char *
smp_sbrk (nbytes)
     int nbytes;
{
	char        *base;
	struct contig_mem *m = contig_mem_ptr;

	//printk ("sheap_ptr: 0x%lx\n", (unsigned long) shm_base);
	//printk ("sheap_end: 0x%lx\n", (unsigned long) m->sbrkaddr);

	if ((m->membase + m->size) >= (m->sbrkaddr + nbytes)) {
		base = m->sbrkaddr;
		m->sbrkaddr += nbytes;
		// printk ("returning base: %p:\n", base);
		return (base);
	} else {
		errno = ENOMEM;
		// printk ("ENOMEM from sbrk()\n");
		return ((char *)-1);
	}
}
