ENTRY(__start)
SEARCH_DIR(.)

/*OUTPUT_FORMAT(elf32-bigmips)*/
OUTPUT_FORMAT(elf64-tradbigmips)
__DYNAMIC = 0;

PROVIDE (hardware_exit_hook = 0);
PROVIDE (hardware_hazard_hook = 0);
PROVIDE (software_init_hook = 0);

PROVIDE ( bucket_sizes = 0);
PROVIDE ( cc_table_cpu_0 = 0); 
PROVIDE ( cc_table_cpu_1 = 0); 
PROVIDE ( cc_table_cpu_2 = 0); 
PROVIDE ( cc_table_cpu_3 = 0); 
PROVIDE ( cc_table_cpu_4 = 0); 
PROVIDE ( cc_table_cpu_5 = 0); 
PROVIDE ( cc_table_cpu_6 = 0); 
PROVIDE ( cc_table_cpu_7 = 0); 
PROVIDE ( cc_table_xgs_0 = 0); 
PROVIDE ( cc_table_xgs_1 = 0); 
PROVIDE ( cc_table_gmac = 0); 
PROVIDE ( cc_table_dma = 0); 
PROVIDE ( cc_table_sec = 0);  

PHDRS
{
    headers PT_PHDR PHDRS ;
    text PT_LOAD FILEHDR PHDRS ;
    data PT_LOAD ;
 	note PT_NOTE FLAGS(4);
}

SECTIONS
{
    . = LOADADDR + SIZEOF_HEADERS;
    _loadaddr = .;

    .init :
    {
    	PROVIDE(__start = .);
        *(.init)
    } :text
    .text :
    {
        _ftext = . ;
        PROVIDE (eprol = .);
        _shim_reg = . ;
        *(.text)
        *(.text.*)
        *(.gnu.linkonce.t*)
        *(.mips16.fn.*)
        *(.mips16.call.*)
    }
    .fini :
    {
        *(.fini)
    }
    PROVIDE (__etext = .);
    PROVIDE (_etext = .);
    PROVIDE (etext = .);
    .rel.sdata :
    {
        PROVIDE (__runtime_reloc_start = .);
        *(.rel.sdata)
        PROVIDE (__runtime_reloc_stop = .);
    }
 	.notes : AT(ADDR(.notes) - 0) { __start_notes = .; *(.note.*) __stop_notes = .; } :text :note
 	.dummy : { *(.dummy) } :text
    .rodata :
    {
        *(.rdata)
        *(.rodata)
        *(.rodata.*)
        *(.gnu.linkonce.r*)
  		PROVIDE (__modules_start = .);
    }
    .data BLOCK(0x800000) :
    {
     _fdata = ABSOLUTE(.);
        *(.data)
        *(.data.*)
        *(.gnu.linkonce.d*)
        . = ALIGN(32);
        _gzip_start = ABSOLUTE(.);
        *(.gzip)
        . = ALIGN(4);
        _gzip_end = ABSOLUTE(.);
        PROVIDE(netos_symtab = .);
 		PROVIDE(netos_symtab_string_t = .);
    } :data
    .eh_frame :
    {
        KEEP (*(.eh_frame))
    }
    .ctors :
    {
        KEEP (*crtbegin.o(.ctors))
        KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
        KEEP (*(SORT(.ctors.*)))
        KEEP (*(.ctors))
    }
    .dtors :
    {
        KEEP (*crtbegin.o(.dtors))
        KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
        KEEP (*(SORT(.dtors.*)))
        KEEP (*(.dtors))
    }
    _gp = ALIGN(16) + 0x7ff0;
    __global = _gp;
    .sdata :
    {
        *(.sdata)
        *(.sdata.*)
        *(.gnu.linkonce.s*)
    }
    . = ALIGN (8);
    .lit8 :
    {
        *(.lit8)
    }
    .lit4 :
    {
        *(.lit4)
    }
    . = ALIGN(4);
     _edata = .;
     PROVIDE (edata = .);
    . = ALIGN(8);
    __init_begin = .;
    .init.text : {
        _sinittext = .;
        *(.init.text)
        _einittext = .;
    }
    .init.data : { *(.init.data) }
    . = ALIGN(16);
    __setup_start = .;
    .init.setup : { *(.init.setup) }
    __setup_end = .;
     _fbss = .;
    .sbss :
    {
        *(.sbss)
        *(.scommon)
    }
    .bss :
    {
        _bss_start = . ;
        *(.bss)
        *(COMMON)
        . = ALIGN (32 / 8);
        . = ALIGN(8192);
        PROVIDE(__stack = . + 12K - 64);
        . = . + 12K;
        __stack_base = .;
        . = . + 12K*32;
        __stack_end = .;
        . = . + 64;
        *(.thread.info)
        . = ALIGN (32);
        _end = .;
        PROVIDE (end = .);
        . = . + 0x800000;
        PROVIDE(_endaddr = ABSOLUTE(.));
    }

    PROVIDE(_program_size = .);

    . = ALIGN(0x800000);

    .debug 0 : { *(.debug) }
    .line 0 : { *(.line) }
    .debug_srcinfo 0 : { *(.debug_srcinfo) }
    .debug_sfnames 0 : { *(.debug_sfnames) }
    .debug_aranges 0 : { *(.debug_aranges) }
    .debug_pubnames 0 : { *(.debug_pubnames) }
    .debug_info 0 : { *(.debug_info) }
    .debug_abbrev 0 : { *(.debug_abbrev) }
    .debug_line 0 : { *(.debug_line) }
    .debug_frame 0 : { *(.debug_frame) }
    .debug_str 0 : { *(.debug_str) }
    .debug_loc 0 : { *(.debug_loc) }
    .debug_macinfo 0 : { *(.debug_macinfo) }
    .debug_weaknames 0 : { *(.debug_weaknames) }
    .debug_funcnames 0 : { *(.debug_funcnames) }
    .debug_typenames 0 : { *(.debug_typenames) }
    .debug_varnames 0 : { *(.debug_varnames) }
}
